
----------- [ Config ] --------
local ABS_SLAVE_PRIO = 3
-------------------------------

local ABS_master = 1
local ABS_Que = {}

-- Stupid ipairs will not iterate if we dont pad!
for i=1,100 do ABS_Que[i] = "1" end

ABS_Que[ABS_SLAVE_PRIO] = "ABSProfiles_slave"

-- * = master
-- ' = slave
---
--- * [1] Ping
--- ' [2] Here I am!
--- * [3] Register slave , wait X seconds
--- * [4] Tell first slave to perform action
--- ' [5] Block outgoing messages, Perform action, Reallow messages, send task done to master
--- * [6] Remove slave from que, GOTO 4, reproccess ADDON que
--- * [7] Cleaning




-- [1] I am master, ping minions, que them and 
-- then send MSG FROM MASTER
function ABS:SendAceMsg(...)
	local master_action,master_profile_name = ...
	
	print("ABS: SendMsg: "..master_action,master_profile_name)
	
	if ABS_master then
		-- [2] I am MASTER, register with this event
		ABS:UnregisterMessage("ProfilesHubPing_MASTER")
		print("ABS: I am master!")
		ABS:RegisterMessage("ABS_QueProfileAddons")
		ABS:SendMessage("ProfilesHubPing_MASTER","ABS_QueProfileAddons",master_action,master_profile_name)
	else
		print("ABS: I am slave!")
		return -- Blocked outgoing messages
	end
end

-- [3] Wait X seconds for slaves and register them
function ABS:ABS_QueProfileAddons(event,slave,priority,master_action,master_profile_name)
	print("ABS: Wait 8 secs: "..event,slave,priority,master_action,master_profile_name)
	ABS_Que[priority] = slave
	
	print ("WHEY! "..ABS_Que[2])
	ABS:ScheduleTimer("ABS_StartSlaves", 8, {master_action,master_profile_name})
end

-- [4] X seconds are up, send action to slaves, when task is finished
-- remove them from que and start again.
function ABS:ABS_StartSlaves(OriginalMessage)
--print("ABS: StartSlaves > "..OriginalMessage[1],OriginalMessage[2])
	ABS:RegisterMessage("ABSProfiles_slave")
	ABS:RegisterMessage("RemoveSlave")

	master_action,master_profile_name = OriginalMessage[1],OriginalMessage[2]

	for prio,slave in ipairs(ABS_Que) do
		
		-- Stupid ipairs will not iterate if we dont pad!
		if slave ~= "1" then
			print("ABS: Starting slave: "..slave.." prio "..prio..master_action,master_profile_name)
			ABS:SendMessage(slave,master_action,master_profile_name)
			return
		end
	end
	
	-- All slaves have performed their task
	ABS:UnregisterMessage("RemoveSlave")

	--TODO: * [7] Cleaning
	
	--TODO: Unique Register messages
	--		to avoid conflicts. time + action+name ?
	
	--TODO: Clean up register messages
	
	--TODO: ABS = self ??
	--		nicer c&p
	
	--TODO: Clean up code
	
	--TODO: DOCUMENTATION
end

--- ' [5] Block outgoing messages, Perform action, Reallow messages, send task done to master
function ABS:ABSProfiles_slave(_,master_action,master_profile_name)
	ABS_master = 0 -- Block outgoing messages
	
print("ABS: Slave-work: "..ABS_master,master_action,master_profile_name)
	
	if master_action == "save" then
		--ABS:SaveABSProfile(master_profile_name)
		print("ABS: Slave task done.")
		ABS:SendMessage("RemoveSlave", master_action, master_profile_name, ABS_SLAVE_PRIO )
	end
	
	if master_action == "load" then
		--ABS:LoadABSProfile(master_profile_name)
		print("ABS: Slave task done.")
		MPS:SendMessage("RemoveSlave", master_action, master_profile_name, ABS_SLAVE_PRIO )
	end
	
	ABS:UnregisterMessage("ABSProfiles_slave")
	
	-- Listen for masters again
	ABS:RegisterMessage("ProfilesHubPing_MASTER","BLAH")
end

--- * [6] Remove slave from que, GOTO 4, reproccess ADDON que
function ABS:RemoveSlave(event,master_action,master_profile_name, slave_prio)
	-- Slave finished task. Remove from que
		print("ABS: Slave done: "..slave_prio)
		ABS_Que[slave_prio] = "1"
		
		-- Process que until there are no more addons in que
		ABS:ABS_StartSlaves({master_action,master_profile_name})
end

-- DUMMY
function ABS:BLAH()
	return
end

ABS:RegisterMessage("ProfilesHubPing_MASTER","BLAH")